{% extends "lab_7/layout/base.html" %}

{% block content %}
    <style>
      /* Always set the map height explicitly to define the size of the div
       * element that contains the map. */
       #map {
           width: 100%;
           height: 400px;
           background-color: grey;
         }
      /* Optional: Makes the sample page fill the window. */
      .controls {
        margin-top: 10px;
        border: 1px solid transparent;
        border-radius: 2px 0 0 2px;
        box-sizing: border-box;
        -moz-box-sizing: border-box;
        height: 32px;
        outline: none;
        box-shadow: 0 2px 6px rgba(0, 0, 0, 0.3);
      }

      #pac-input {
        background-color: #fff;
        font-family: Roboto;
        font-size: 15px;
        font-weight: 300;
        padding: 0 11px 0 13px;
        text-overflow: ellipsis;
        width: 300px;
      }

      #pac-input:focus {
        border-color: #4d90fe;
      }

      .pac-container {
        font-family: Roboto;
      }

      #type-selector {
        color: #fff;
        background-color: #4d90fe;
        padding: 5px 11px 0px 11px;
      }

      #type-selector label {
        font-family: Roboto;
        font-size: 13px;
        font-weight: 300;
      }
      #target {
        width: 345px;
      }
    </style>
    <section name="friend-list" id="friend-list">
        <div class="container">
            <div class="row">
                <div class="col-md-6 col-lg-6">
                    <h3>Google Maps</h3>
                    <input id="pac-input" class="controls" type="text" placeholder="Search Box">
                    <div id="map"></div>
                </div>
                <div class="col-lg-6">
                    <h2> Friend Fasilkom</h2>
                    <div id="friend-list" class="list-group">
                        {% if friend_list %}
                            {% csrf_token %}
                            <div id="all-friend"></div>
                        {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada teman
                        </div>
                        {% endif %}
                    </div>
                    <a href="/lab-7/">
                        <button style="margin-left: 200px;">Kembali ke Halaman Utama</button>
                    </a>
                </div>
            </div>
        </div>
    </section>
{% endblock %}
{% block javascript %}
    <script>
        $( document ).ready(function () {
            {# lengkapi pemanggilan ajax berikut untuk mengambil daftar teman yang ada di database #}
            $.ajax({
                method: "GET",
                url: '{% url "lab-7:get-friend-list-json" %}',
                dataType: 'json',
                success: function (data) {
                    console.log(data.length);
                    if (data.length == 0) {
                        html = '<div class="alert alert-danger text-center">' +
                                '<strong>Opps!</strong> Tidak ada teman' +
                            +'</div>';
                        $("#all-friend").append(html);
                    }
                    else {
                        console.log(data)
                        for (var key in data){
                        console.log(key);
                        var buttonDelete = '<span class="btn btn-default btn-danger" onClick="deleteFriend('+ "'" + data[key].fields.friend_name + "'" 
                            + ', '+ "'" + data[key].fields.npm + "'" + ');"'+ 'style="float: right; margin-left: 5px;"'+'>Delete</span>';
                        var addressButton = '<span class="btn btn-default btn-danger" id="searchButton" onClick="checkAddress('+ "'" + data[key].fields.alamat + "'" 
                            +'); refreshGmap(' + "'" + data[key].fields.npm + "'" + ');"'+ 'style="float: right; background-color: blue;"'+'>Data</span>';
                        var dataMahasiswa = '<div class="list-group-item clearfix" id="data-' + data[key].fields.npm + '" style="display: none;">' + '<a class="list-group-item clearfix">Alamat: ' +
                            data[key].fields.alamat + '</a>'+ '<a class="list-group-item clearfix">Kode Pos: ' +
                            data[key].fields.kode_pos + '</a>' + '<a class="list-group-item clearfix">Kota Lahir: ' +
                            data[key].fields.kota_lahir + '</a>' + '<a class="list-group-item clearfix">Tanggal Lahir: ' +
                            data[key].fields.tgl_lahir + '</a>' + '</div>';
                        html = '<a class="list-group-item clearfix" '+ 'id='+ data[key].fields.npm + '>' +
                            data[key].fields.friend_name + " (" + data[key].fields.npm + ")"+ buttonDelete + addressButton + dataMahasiswa +
                            '</a>';
                        $("#all-friend").append(html);
                        }
                    }
                    
                },
                error: function(error){
                    alert("Data gagal diterima");
                    html = '<div class="alert alert-danger text-center">' +
                                '<strong>Opps!</strong> Tidak ada teman' +
                            +'</div>';
                    $("#all-friend").append(html);
                }
            });
        });

        var deleteFriend = function(nama, npm) {
            $.ajax({
                method: "POST",
                url: '{% url "lab-7:delete-friend" %}',
                data: { name: nama, npm: npm},
                success : function (response) {
                    $("#" + npm).remove()
                },
                error : function (error) {
                    alert("Mahasiswa tersebut tidak ada");
                }
            });
         };

    </script>
    <script>
        var checkAddress = function(alamat) {
            $('#pac-input').val(alamat);
         };

        var refreshGmap = function (npm) {
            var input = document.getElementById('pac-input');
            google.maps.event.trigger(input, 'focus')
            google.maps.event.trigger(input, 'keydown', { keyCode: 13 });
            var box = document.getElementById('data-' + npm);
              if (box.style.display === "block"){
                box.style.display = "none";
              }
              else {
                box.style.display = "block";
              }
        };    
      function initAutocomplete() {
        var map = new google.maps.Map(document.getElementById('map'), {
          center: {lat: -2.407468, lng: 112.363101},
          zoom: 5,
          mapTypeId: 'roadmap'
        });

        var marker = new google.maps.Marker({
          position: {lat: -2.407468, lng: 112.363101},
          map: map,
        });

        // Create the search box and link it to the UI element.
        var input = document.getElementById('pac-input');
        var searchBox = new google.maps.places.SearchBox(input);
        map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);

        // Bias the SearchBox results towards current map's viewport.
        map.addListener('bounds_changed', function() {
          searchBox.setBounds(map.getBounds());
        });

        var markers = [];
        // Listen for the event fired when the user selects a prediction and retrieve
        // more details for that place.
        searchBox.addListener('places_changed', function() {
          var places = searchBox.getPlaces();

          if (places.length == 0) {
            return;
          }

          // Clear out the old markers.
          markers.forEach(function(marker) {
            marker.setMap(null);
          });
          markers = [];

          // For each place, get the icon, name and location.
          var bounds = new google.maps.LatLngBounds();
          places.forEach(function(place) {
            if (!place.geometry) {
              console.log("Returned place contains no geometry");
              return;
            }
            var icon = {
              url: place.icon,
              size: new google.maps.Size(71, 71),
              origin: new google.maps.Point(0, 0),
              anchor: new google.maps.Point(17, 34),
              scaledSize: new google.maps.Size(25, 25)
            };

            // Create a marker for each place.
            markers.push(new google.maps.Marker({
              map: map,
              icon: icon,
              title: place.name,
              position: place.geometry.location
            }));

            if (place.geometry.viewport) {
              // Only geocodes have viewport.
              bounds.union(place.geometry.viewport);
            } else {
              bounds.extend(place.geometry.location);
            }
          });
          map.fitBounds(bounds);
        });
      }
    </script>
    <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyALpWCOORH_gKX_X55Svi7JUyK2q0JVxNA&libraries=places&callback=initAutocomplete"
         async defer></script>
{% endblock %}
